require 'fuelcell/help/builder'
require 'fuelcell/help/base_formatter'
require 'fuelcell/help/usage_formatter'
require 'fuelcell/help/opts_formatter'
require 'fuelcell/help/cmds_formatter'
require 'fuelcell/help/desc_formatter'

module Fuelcell
  module Help
    class << self
      def generate(root, args = [], width = 80)
        data = Builder.new.call(root, args)
        text = UsageFormatter.new(width: width).call(data)

        line = DescFormatter.new(width: width).call(data)
        text << "\n" + line unless line.empty?

        line = OptsFormatter.new(width: width).call(data)
        text << "\n" + line unless line.empty?

        line = CmdsFormatter.new(width: width).call(data)
        text << "\n" + line unless line.empty?
        text
      end
    end
  end
end
