module Fuelcell
  module Help
    # Hold common functionality and information needed by all formatters
    class BaseFormatter
      DEFAULT_WIDTH   = 80
      DEFAULT_PADDING = 4
      attr_reader :width, :padding, :max_width

      def initialize(config = {})
        @width     = config[:width] || DEFAULT_WIDTH
        @padding   = config[:padding] || DEFAULT_PADDING
        @max_width = width - padding
      end

      def short_opt(data, no_opt = '')
        data[:short].nil? ? no_opt : "-#{data[:short]}"
      end

      def long_opt(data, no_opt = '')
        data[:long].nil? ? no_opt : "--#{data[:long]}=#{data[:long].upcase}"
      end
    end
  end
end
