module Fuelcell
  module Help
    class DescFormatter < BaseFormatter

      def call(data)
        return '' if empty?(data)
        wrap(data[:long_desc] || data[:desc]) + "\n"
      end

      def wrap(text)
        pattern = /(.{1,#{max_width}})(\s+|$)/
        text.gsub(pattern, "\\1\n").strip
      end

      def empty?(data)
        (!data.key?(:desc) || data[:desc].to_s.empty?) &&
          (!data.key?(:long_desc) || data[:long_desc].to_s.empty?)
      end
    end
  end
end
