module Fuelcell
  module Parser
    class CmdArgsStrategy

      # Extract arguments that form the command to be executed.
      #
      # This will collect all arguments up to the first option or the ignore
      # symbol --. It separates and returns the command args as an array of
      # strings that form a heirarchal route to the command. These command args
      # are removed from the raw arg list
      #
      #
      # @param [Array] raw args from ARGV
      # @return <Array>
      def call(args)
        cmd_args = []
        while item = args.shift
          if item.start_with?('-')
            args.unshift(item)
            break
          end
          cmd_args << item
        end
        cmd_args
      end
    end
  end
end
